<?php
/**********************************************************************************
* ProfilePictures.php                                                                      *
***********************************************************************************
* Version: 0.9
* This file is a part of Ultimate Profile mod
* Author: Jovan Turanjanin                                                      *
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');


function PicturesController ($memID)
{
	global $context, $modSettings, $db_prefix, $txt;
	
	loadTemplate('ProfilePictures');
	
	loadThemeOptions ($memID);
	if ((@$context['member']['options']['pictures_budd_only'] == 1 || @$context['member']['options']['customized_private'] == 1) && @$modSettings['enable_buddylist'] == 1) {
		if (is_buddy($memID, $context['user']['id']) || allowedTo('edit_ultimate_profile_any') || $context['user']['is_owner'])
			$context['can_view_pics'] = true;
		else
			$context['can_view_pics'] = false;
	} else
		$context['can_view_pics'] = true;
	
	
	if ($modSettings['profile_enable_pictures'] != 1 || !$context['can_view_pics'])
		fatal_error($txt['profile_picture_not_allowed'], false);
	
	// Permisions
	$allowed_edit = false;
	$allowed_add = false;
	$allowed_album_modify = false;
		
	if (allowedTo('edit_ultimate_profile_any')) {
		$allowed_edit = true;
		$allowed_add = true;
		$allowed_album_modify = true;

	} elseif ($context['user']['is_owner'] && allowedTo('edit_ultimate_profile_own')) {
		$allowed_add = true;
		$allowed_album_modify = true;
		
		// Are you editing picture that is on your own profile?
		$temp_id = isset($_GET['view']) ? $_GET['view'] : (isset($_GET['edit']) ? $_GET['edit'] : (isset($_GET['edit2']) ? $_GET['edit2'] : (isset($_GET['delete']) ? $_GET['delete'] : '')));
		$request = db_query('SELECT ID_MEMBER 
			FROM ' . $db_prefix . 'profile_pictures 
			WHERE ID_PICTURE = "' . (int)$temp_id . '"', __FILE__, __LINE__);
		list($user_id) = mysql_fetch_row($request);
		
		if ($context['user']['id'] == $user_id)
			$allowed_edit = true;
		
		// What about albums?
		$temp_id2 = isset($_GET['album']) ? $_GET['album'] : (isset($_GET['editalb']) ? $_GET['editalb'] : (isset($_GET['editalb2']) ? $_GET['editalb2'] : (isset($_GET['deletealb']) ? $_GET['deletealb'] : '')));
		if ($temp_id2 !== '') {
			$request = db_query('SELECT ID_MEMBER 
				FROM ' . $db_prefix . 'profile_albums 
				WHERE ID_ALBUM = "' . (int)$temp_id2 . '"', __FILE__, __LINE__);
			list($user_id) = mysql_fetch_row($request);
		
			if ($context['user']['id'] == $user_id)
				$allowed_album_modify = true;
		}
	}
	
	if (isset($_GET['add']) || isset($_GET['add2'])) {
		if ($modSettings['profile_pictures_number'] > 0) { // 0 means unlimited :D.
			$request = db_query('SELECT COUNT(ID_PICTURE) 
				FROM ' . $db_prefix . 'profile_pictures 
				WHERE ID_MEMBER = ' . $memID, __FILE__, __LINE__);
			list($pic_count) = mysql_fetch_row($request);
			
			if ($pic_count >= $modSettings['profile_pictures_number'])
				fatal_error($txt['profile_pictures_over'], false);
		}
	}
	
	$context['can_add'] = $allowed_add;	
	
	// I can't use switch($_GET) here so I'm stuck with elseifs... It will work :)
	if (isset($_GET['add'])) {
		AddPicture($allowed_add);
	} elseif (isset($_GET['add2'])) {
		AddPicture2($allowed_add);
	} elseif (isset($_GET['edit'])) {
		EditPicture($allowed_edit);
	} elseif (isset($_GET['edit2'])) {
		EditPicture2($allowed_edit);
	} elseif (isset($_GET['delete'])) {
		DeletePicture($allowed_edit);
	} elseif (isset($_GET['addalb'])) {
		AddAlbum($allowed_album_modify);
	} elseif (isset($_GET['addalb2'])) {
		AddAlbum2($allowed_album_modify);
	} elseif (isset($_GET['editalb'])) {
		EditAlbum($allowed_album_modify);
	} elseif (isset($_GET['editalb2'])) {
		EditAlbum2($allowed_album_modify);
	} elseif (isset($_GET['deletealb'])) {
		DeleteAlbum($allowed_album_modify);
	} elseif (isset($_GET['comment'])) {
		AddPictureComment();
	} elseif (isset($_GET['delcomment'])) {
		DeletePictureComment();
	} elseif (isset($_GET['view'])) {
		ViewPicture($allowed_edit);
	} else {
		ShowAlbum($allowed_album_modify);
	}
}

function AddPicture ($allowed_add)
{
	global $context, $txt, $scripturl;
	
	if (!$allowed_add)
		fatal_error($txt['profile_pictures_add_not'], false);
	
	if (isset($_GET['add']))
		$context['album_parent'] = (int)$_GET['add'];
	$context['sub_template'] = 'pictures_edit';
	$context['album_tree'] = build_tree();
	$context['profile_action'] = $scripturl . '?action=profile;sa=pictures;add2';
	$context['picture_upload'] = true;
}

function AddPicture2 ($allowed_add)
{
	global $txt, $db_prefix, $sourcedir, $modSettings, $context;
	
	$memID = $context['member']['id'];
	
	checkSession('post');
		
	if (!$allowed_add)
		fatal_error($txt['profile_pictures_add_not'], false);
		
	if (!isset($_POST['title']) || !isset($_POST['description']) || !isset($_FILES['picture']) || !isset($_POST['album_id']))
		fatal_error($txt['profile_pictures_fields'], false);
	
	if ($_POST['album_id'] > 0) {
		$request = db_query('SELECT pictures 
			FROM ' . $db_prefix . 'profile_albums 
			WHERE ID_ALBUM = "' . (int)$_POST['album_id'] . '"', __FILE__, __LINE__);
		if (mysql_num_rows($request) < 1)
			fatal_error($txt['profile_albums_parent_not'], false);
	}
	
	// Are there any errors during upload?
	if (!($_FILES['picture']['error'] == '0') || !file_exists($_FILES['picture']['tmp_name']) || !is_uploaded_file($_FILES['picture']['tmp_name']))
		fatal_error($txt['profile_pictures_upload_fail'], false);
	
	// Is this file a picture or something else?
	$picture = getimagesize($_FILES['picture']['tmp_name']);
	if ($picture == NULL)
		fatal_error($txt['profile_pictures_pic_not'], false);
	
	$time = time();
	$filename = $memID . '_' . $time . '.' . get_extension($_FILES['picture']['name']);
	$thumb_filename = $memID . '_' . $time . '_thumb.' . get_extension($_FILES['picture']['name']);
	
	move_uploaded_file($_FILES['picture']['tmp_name'], $modSettings['profile_pictures_path'] . '/tmp_' . $memID);
	
	// Let's make thumbnails :).
	unset($modSettings['avatar_download_png']); // Delete this line if you want PNG thumbnails (better quality (lossless), much bigger files).
	require_once $sourcedir . '/Subs-Graphics.php';
	createThumbnail($modSettings['profile_pictures_path'] . '/tmp_' . $memID, 120, 89);
	rename($modSettings['profile_pictures_path'] . '/tmp_' . $memID . '_thumb', $modSettings['profile_pictures_path'] . '/' . $thumb_filename);
	
	createThumbnail($modSettings['profile_pictures_path'] . '/tmp_' . $memID, $modSettings['profile_pictures_width'], '');
	rename($modSettings['profile_pictures_path'] . '/tmp_' . $memID . '_thumb', $modSettings['profile_pictures_path'] . '/' . $filename);
	
	@unlink($modSettings['profile_pictures_path'] . '/tmp_' . $memID);
	
	db_query('INSERT INTO ' . $db_prefix . 'profile_pictures SET 
		ID_MEMBER = "' . $memID . '", 
		time = "' . $time . '",
		title = \'' . htmlspecialchars($_POST['title']) . '\', 
		description = \'' . htmlspecialchars($_POST['description']) . '\',
		filename = \'' . htmlspecialchars($_FILES['picture']['name']) . '\', 
		ID_ALBUM = "' . (int)$_POST['album_id'] . '"', __FILE__, __LINE__);
	
	if ($_POST['album_id'] > 0)
		db_query('UPDATE ' . $db_prefix . 'profile_albums SET 
			pictures = pictures + 1 
			WHERE ID_ALBUM = ' . (int)$_POST['album_id'], __FILE__, __LINE__);
	
	redirectexit('action=profile;u=' . $memID . ';sa=pictures;album=' . $_POST['album_id']);
}

function EditPicture ($allowed_edit)
{
	global $context, $txt, $db_prefix, $scripturl;
	
	if (!$allowed_edit)
		fatal_error($txt['profile_pictures_edit_not'], false);
		
	$request = db_query('SELECT title, description, ID_ALBUM 
		FROM ' . $db_prefix . 'profile_pictures 
		WHERE ID_PICTURE = "' . (int)$_GET['edit'] . '"', __FILE__, __LINE__);
	list($context['picture_title'], $context['picture_description'], $context['album_parent']) = mysql_fetch_row($request);
	
	$context['sub_template'] = 'pictures_edit';
	$context['album_tree'] = build_tree();
	$context['profile_action'] = $scripturl . '?action=profile;sa=pictures;edit2=' . $_GET['edit'];
	$context['picture_upload'] = false;
}

function EditPicture2 ($allowed_edit)
{
	global $txt, $db_prefix, $context;
	
	$memID = $context['member']['id'];
	
	checkSession('post');
		
	if (!$allowed_edit)
		fatal_error($txt['profile_pictures_edit_not'], false);
	
	if (!isset($_POST['title']) || !isset($_POST['description']) || !isset($_POST['album_id']))
		fatal_error($txt['profile_pictures_fields'], false);
	
	if ($_POST['album_id'] > 0) {
		$request = db_query('SELECT pictures 
			FROM ' . $db_prefix . 'profile_albums 
			WHERE ID_ALBUM = "' . (int)$_POST['album_id'] . '"', __FILE__, __LINE__);
		if (mysql_num_rows($request) < 1)
			fatal_error($txt['profile_albums_parent_not'], false);
	}
	
	// Stupid picture count field :P
	$request = db_query('SELECT ID_ALBUM 
		FROM ' . $db_prefix . 'profile_pictures 
		WHERE ID_PICTURE = "' . (int)$_GET['edit2'] . '"', __FILE__, __LINE__);
	list($old_album_id) = mysql_fetch_row($request);
	
	db_query('UPDATE ' . $db_prefix . 'profile_pictures SET
		title = \'' . htmlspecialchars($_POST['title']) . '\',
		description = \'' . htmlspecialchars($_POST['description']) . '\',
		ID_ALBUM = "' . (int)$_POST['album_id'] . '"
		WHERE ID_PICTURE = "' . $_GET['edit2'] . '"', __FILE__, __LINE__);
	
	if ($old_album_id !== $_POST['album_id']) {
		db_query('UPDATE ' . $db_prefix . 'profile_albums SET 
			pictures = pictures - 1 
			WHERE ID_ALBUM = ' . $old_album_id, __FILE__, __LINE__);
		db_query('UPDATE ' . $db_prefix . 'profile_albums SET 
			pictures = pictures + 1 
			WHERE ID_ALBUM = ' . (int)$_POST['album_id'], __FILE__, __LINE__);
	}
	
	redirectexit('action=profile;u=' . $memID . ';sa=pictures;album=' . $_POST['album_id']);
}

function DeletePicture ($allowed_edit)
{
	global $txt, $db_prefix, $modSettings, $context;
	
	$memID = $context['member']['id'];
	
	checkSession('get');
		
	if (!$allowed_edit)
		fatal_error($txt['profile_pictures_delete_not'], false);
	
	$album_id = delete_picture($_GET['delete']);
	
	redirectexit('action=profile;u=' . $memID . ';sa=pictures;album=' . $album_id);
}

function AddAlbum ($allowed_add)
{
	global $context, $txt, $scripturl;
	
	if (!$allowed_add)
		fatal_error($txt['profile_albums_add_not'], false);
	
	if (isset($_GET['addalb']))
		$context['album_parent'] = (int)$_GET['addalb'];
	$context['sub_template'] = 'albums_edit';
	$context['album_tree'] = build_tree();
	$context['profile_action'] = $scripturl . '?action=profile;sa=pictures;addalb2';
}

function AddAlbum2 ($allowed_add) {
	global $txt, $db_prefix, $sourcedir, $modSettings, $context;
	
	$memID = $context['member']['id'];
	
	checkSession('post');
		
	if (!$allowed_add)
		fatal_error($txt['profile_albums_add_not'], false);
		
	if (!isset($_POST['title']) || !isset($_POST['parent_id']))
		fatal_error($txt['profile_albums_fields'], false);
	
	if ($_POST['parent_id'] > 0) {
		$request = db_query('SELECT pictures 
			FROM ' . $db_prefix . 'profile_albums 
			WHERE ID_ALBUM = "' . (int)$_POST['parent_id'] . '"', __FILE__, __LINE__);
		if (mysql_num_rows($request) < 1)
			fatal_error($txt['profile_albums_parent_not'], false);
	}

		
	db_query('INSERT INTO ' . $db_prefix . 'profile_albums SET 
		ID_MEMBER = "' . $memID . '", 
		title = \'' . htmlspecialchars($_POST['title']) . '\', 
		pictures = 0,
		PARENT_ID = "' . (int)$_POST['parent_id'] . '"', __FILE__, __LINE__);
	
	redirectexit('action=profile;u=' . $memID . ';sa=pictures;album=' . $_POST['parent_id']);
}

function EditAlbum ($allowed_edit)
{
	global $context, $txt, $db_prefix, $scripturl;
	
	if (!$allowed_edit)
		fatal_error($txt['profile_albums_edit_not'], false);
		
	$request = db_query('SELECT title, PARENT_ID 
		FROM ' . $db_prefix . 'profile_albums 
		WHERE ID_ALBUM = "' . (int)$_GET['editalb'] . '"', __FILE__, __LINE__);
	list($context['album_title'], $context['album_parent']) = mysql_fetch_row($request);
	
	$context['sub_template'] = 'albums_edit';
	$context['album_tree'] = build_tree($_GET['editalb']);
	$context['profile_action'] = $scripturl . '?action=profile;sa=pictures;editalb2=' . $_GET['editalb'];
}

function EditAlbum2 ($allowed_edit)
{
	global $txt, $db_prefix, $context;
	
	$memID = $context['member']['id'];
	
	checkSession('post');
		
	if (!$allowed_edit)
		fatal_error($txt['profile_albums_edit_not'], false);
	
	if (!isset($_POST['title']) || !isset($_POST['parent_id']))
		fatal_error($txt['profile_albums_fields'], false);
	
	if ($_POST['parent_id'] > 0) {
		$request = db_query('SELECT pictures 
			FROM ' . $db_prefix . 'profile_albums 
			WHERE ID_ALBUM = "' . (int)$_POST['parent_id'] . '"', __FILE__, __LINE__);
		if (mysql_num_rows($request) < 1)
			fatal_error($txt['profile_albums_parent_not'], false);
	}
	
	db_query('UPDATE ' . $db_prefix . 'profile_albums SET
		title = \'' . htmlspecialchars($_POST['title']) . '\',
		PARENT_ID = "' . (int)$_POST['parent_id'] . '" 
		WHERE ID_ALBUM = "' . (int)$_GET['editalb2'] . '"', __FILE__, __LINE__);
	
	redirectexit('action=profile;u=' . $memID . ';sa=pictures;album=' . $_GET['editalb2']);
}

function DeleteAlbum ($allowed_edit)
{
	global $txt, $db_prefix, $modSettings, $context;
	
	$memID = $context['member']['id'];
	
	checkSession('get');
		
	if (!$allowed_edit)
		fatal_error($txt['profile_albums_delete_not'], false);
	
	if ($_GET['deletealb'] == 0)
		redirectexit('action=profile;u=' . $memID . ';sa=pictures');
	
	$request = db_query('SELECT PARENT_ID 
		FROM ' . $db_prefix . 'profile_albums 
		WHERE ID_ALBUM = ' . (int)$_GET['deletealb'], __FILE__, __LINE__);
	list($parent_id) = mysql_fetch_row($request);
	
	delete_album($_GET['deletealb']);
	
	redirectexit('action=profile;u=' . $memID . ';sa=pictures;album=' . $parent_id);
}

function AddPictureComment()
{
	global $txt, $context, $db_prefix, $sourcedir, $scripturl, $modSettings, $language;
	
	$memID = $context['member']['id'];
	
	// Guests are not allowed to comment.
	is_not_guest();

	if (empty($_POST['comment']))
		fatal_error($txt['profile_comment_field'], false);
	
	// Integration with AEVA mod (Thanks Nao 尚 ;))
	if (isset($modSettings['aeva_enable']) && file_exists($sourcedir . '/Subs-Aeva.php')) {
		@include_once($sourcedir . '/Subs-Aeva.php');
		if (function_exists('aeva_onposting'))
			$_POST['comment'] = aeva_onposting($_POST['comment']);
	}
		
	checkSession('post');
	
	// Only buddies can post comments?
	if (isset($context['member']['options']['comments_budd_only']) && $context['member']['options']['comments_budd_only'] == 1) {
		if (!is_buddy($memID, $context['user']['id']) && !allowedTo('edit_ultimate_profile_any'))
			fatal_error($txt['profile_comments_buddies_only'], false);
	}
		
	
	$request =	db_query('INSERT INTO ' . $db_prefix . 'picture_comments SET
		ID_MEMBER = "' . $context['user']['id'] . '",
		comment = \'' . htmlspecialchars($_POST['comment']) . '\',
		time = "' . time() . '",
		COMMENT_PICTURE_ID = "' . (int)$_GET['comment'] . '"', __FILE__, __LINE__);
	
	// Should we notify the user?
	if (@$context['member']['options']['comments_notif_disable'] != 1 && $context['user']['id'] != $memID) {
		$request = db_query('SELECT lngfile 
			FROM ' . $db_prefix . 'members 
			WHERE ID_MEMBER = ' . $memID, __FILE__, __LINE__);
		list($user_language) = mysql_fetch_row($request);
		
		loadLanguage('UltimateProfile', empty($user_language) || empty($modSettings['userLanguage']) ? $language : $user_language, false);
		
		require_once $sourcedir . '/Subs-Post.php';
		sendpm(array('to' => array($memID), 'bcc' => array()), sprintf($txt['profile_notif_piccom_subject'], $context['user']['name']), sprintf($txt['profile_notif_piccom_body'], $context['user']['name'], $scripturl . '?action=profile;sa=pictures;view=' . (int)$_GET['comment']), false, array('id' => 0, 'name' => $txt['profile_notif_com_user'], 'username' => $txt['profile_notif_com_user']));
	}
		
	redirectexit('action=profile;u=' . $memID . ';sa=pictures;view=' . (int)$_GET['comment']);
}

function DeletePictureComment()
{
	global $context, $db_prefix, $context;
	
	$memID = $context['member']['id'];
	
	checkSession('get');
		
	$allowed = false;
	
	if (allowedTo('edit_ultimate_profile_any'))
		$allowed = true;
	elseif ($context['user']['is_owner'] && allowedTo('edit_ultimate_profile_own')) {
		// Are you deleting comment that is on your own profile?
		$request = db_query('SELECT pic.ID_MEMBER
			FROM (' . $db_prefix . 'picture_comments AS com, ' . $db_prefix . 'profile_pictures AS pic)
			WHERE com.COMMENT_PICTURE_ID = pic.ID_PICTURE 
				AND com.ID_COMMENT = "' . (int)$_GET['delcomment'] . '"', __FILE__, __LINE__);
		list($user_id) = mysql_fetch_row($request);
		
		if ($context['user']['id'] == $user_id)
			$allowed = true;
	}
	
	$request = db_query('SELECT COMMENT_PICTURE_ID 
		FROM ' . $db_prefix . 'picture_comments 
		WHERE ID_COMMENT = "' . (int)$_GET['delcomment'] . '"', __FILE__, __LINE__);
	list($picture_id) = mysql_fetch_row($request);
	
	if ($allowed)
		db_query('DELETE FROM ' . $db_prefix . 'picture_comments 
			WHERE ID_COMMENT = "' . (int)$_GET['delcomment'] . '"', __FILE__, __LINE__);
	
	redirectexit('action=profile;u=' . $memID . ';sa=pictures;view=' . $picture_id);
}

function ViewPicture ($allowed_edit)
{
	global $db_prefix, $txt, $context, $scripturl, $modSettings, $settings;
	
	$memID = $context['member']['id'];
	
	$request = db_query('SELECT time, title, description, filename, ID_ALBUM
		FROM ' . $db_prefix . 'profile_pictures
		WHERE ID_MEMBER = ' . $memID . ' 
			AND ID_PICTURE = ' . (int)$_GET['view'], __FILE__, __LINE__);
	if (mysql_num_rows($request) < 1)
		fatal_error($txt['profile_pictures_not_found'], false);
	
	
	$context['picture'] = mysql_fetch_assoc($request);
	$context['picture']['image'] = $modSettings['profile_pictures_url'] . '/' . $memID . '_' . $context['picture']['time'] . '.' . get_extension($context['picture']['filename']);
	$context['picture']['time'] = timeformat($context['picture']['time']);
	
	$request = db_query('SELECT title	
		FROM ' . $db_prefix . 'profile_albums 
		WHERE ID_ALBUM = ' . $context['picture']['ID_ALBUM'], __FILE__, __LINE__);
	list($context['album']['title']) = mysql_fetch_row($request);
	
	if ($allowed_edit) {
		$context['picture']['edit'] = $scripturl . '?action=profile;u=' . $memID . ';sa=pictures;edit=' . $_GET['view'];
		$context['picture']['delete'] = $scripturl . '?action=profile;u=' . $memID . ';sa=pictures;delete=' . $_GET['view'] . ';sesc=' . $context['session_id'];
	}
	
	// Prepare and load comments.
	$request = db_query('SELECT COUNT(*)
		FROM ' . $db_prefix . 'picture_comments 
		WHERE COMMENT_PICTURE_ID = "' . (int)$_GET['view'] . '"', __FILE__, __LINE__);
	list($commentCount) = mysql_fetch_row($request);
	mysql_free_result($request);

	$maxComments = 10; // Hard-coded; should this be configurable?
	
	// For avatars: if we're always html resizing, assume it's too large.
	if ($modSettings['avatar_action_too_large'] == 'option_html_resize' || $modSettings['avatar_action_too_large'] == 'option_js_resize') {
		$avatar_width = !empty($modSettings['avatar_max_width_external']) ? ' width="' . $modSettings['avatar_max_width_external'] . '"' : '';
		$avatar_height = !empty($modSettings['avatar_max_height_external']) ? ' height="' . $modSettings['avatar_max_height_external'] . '"' : '';
	} else {
		$avatar_width = '';
		$avatar_height = '';
	}

	// Make sure the starting place makes sense and construct our friend the page index.
	$context['start'] = (int)$_REQUEST['start'];
	$context['page_index'] = constructPageIndex($scripturl . '?action=profile;u=' . $memID . ';sa=pictures;view=' . $_GET['view'], $context['start'], $commentCount, $maxComments, false);
	$context['current_page'] = $context['start'] / $maxComments;
	$context['current_member'] = $memID;
	$context['can_delete'] = allowedTo('edit_ultimate_profile_any') || ($context['user']['is_owner'] && allowedTo('edit_ultimate_profile_own'));
		
	$request = db_query('SELECT com.ID_COMMENT, com.ID_MEMBER, com.comment, com.time, mem.realName, mem.showOnline, 
				IFNULL(lo.logTime, 0) AS isOnline, IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType, mem.avatar
				FROM ' . $db_prefix . 'picture_comments as com
					LEFT JOIN ' . $db_prefix . 'members AS mem ON (com.ID_MEMBER = mem.ID_MEMBER)
					LEFT JOIN ' . $db_prefix . 'log_online AS lo ON (lo.ID_MEMBER = com.ID_MEMBER)
					LEFT JOIN ' . $db_prefix . 'attachments AS a ON (a.ID_MEMBER = com.ID_MEMBER)
				WHERE com.COMMENT_PICTURE_ID = ' . (int)$_GET['view'] . ' 
				ORDER BY ID_COMMENT DESC 
				LIMIT ' . $context['start'] . ', ' . $maxComments, __FILE__, __LINE__);
	
	while ($row = mysql_fetch_assoc($request)) {
		
		censorText($row['comment']);
		
		$row['is_online'] = (!empty($row['showOnline']) || allowedTo('moderate_forum')) && $row['isOnline'] > 0;
		
		$context['comments'][] = array (
			'body' => parse_bbc($row['comment']),
			'author' => array (
				'realName' => $row['realName'],
				'ID_MEMBER' => $row['ID_MEMBER'],
				'avatar' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '"' . $avatar_width . $avatar_height . ' alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'online' => array (
					'is_online' => $row['is_online'],
					'text' => &$txt[$row['is_online'] ? 'online2' : 'online3'],
					'href' => $scripturl . '?action=pm;sa=send;u=' . $row['ID_MEMBER'],
					'link' => '<a href="' . $scripturl . '?action=pm;sa=send;u=' . $row['ID_MEMBER'] . '">' . $txt[$row['is_online'] ? 'online2' : 'online3'] . '</a>',
					'image_href' => $settings['images_url'] . '/' . ($row['is_online'] ? 'useron' : 'useroff') . '.gif',
					'label' => &$txt[$row['is_online'] ? 'online4' : 'online5']
				),
			),
			'time' => timeformat($row['time']),
			'delete' => $scripturl . '?action=profile;u=' . $memID . ';sa=pictures;delcomment=' . $row['ID_COMMENT'] . ';sesc=' . $context['session_id'],
		);
		
	}
	mysql_free_result($request);
	
	
	// Previous/next picture.
	$request = db_query('SELECT ID_PICTURE 
		FROM ' . $db_prefix . 'profile_pictures 
		WHERE ID_PICTURE < ' . (int)$_GET['view'] . ' 
			AND ID_MEMBER = ' . $memID . ' 
			AND ID_ALBUM = ' . $context['picture']['ID_ALBUM'] . ' 
		ORDER BY ID_PICTURE DESC 
		LIMIT 1', __FILE__, __LINE__);
	list($context['picture']['previous_id']) = mysql_fetch_row($request);
	
	$request = db_query('SELECT ID_PICTURE 
		FROM ' . $db_prefix . 'profile_pictures 
		WHERE ID_PICTURE > ' . (int)$_GET['view'] . ' 
			AND ID_MEMBER = ' . $memID . ' 
			AND ID_ALBUM = ' . $context['picture']['ID_ALBUM'] . ' 
		ORDER BY ID_PICTURE ASC 
		LIMIT 1', __FILE__, __LINE__);
	list($context['picture']['next_id']) = mysql_fetch_row($request);
	
	$context['sub_template'] = 'pictures_view';
}

function ShowAlbum ($allowed_album_modify)
{
	global $db_prefix, $context, $modSettings, $scripturl, $txt;
	
	$memID = $context['member']['id'];
	$albumID = isset($_GET['album']) ? (int)$_GET['album'] : 0;
	
	// Album info
	if ($albumID == 0) {
		$context['album']['id'] = 0;
		
		$request = db_query('SELECT COUNT(ID_PICTURE) 
			FROM ' . $db_prefix . 'profile_pictures 
			WHERE ID_MEMBER = ' . $memID . ' 
				AND ID_ALBUM = 0', __FILE__, __LINE__);
		list($context['album']['pictures_count']) = mysql_fetch_row($request);
		
	} else {
		$request = db_query('SELECT ID_ALBUM, title, pictures, PARENT_ID 
			FROM ' . $db_prefix . 'profile_albums
			WHERE ID_MEMBER = ' . $memID . ' 
				AND ID_ALBUM = ' . $albumID, __FILE__, __LINE__);
		list($context['album']['id'], $context['album']['title'], $context['album']['pictures_count'], $context['album']['parent_id']) = mysql_fetch_row($request);
		
		if (mysql_num_rows ($request) < 1)
			fatal_error($txt['profile_album_not_found'], false);
	
		$context['can_edit'] = $allowed_album_modify;
	}
		
	// Make sure the starting place makes sense and construct our friend the page index.
	$maxPictures = 10; // hard-coded; should this be configurable?
	$context['start'] = (int)$_REQUEST['start'];
	$context['page_index'] = constructPageIndex($scripturl . '?action=profile;u=' . $memID . ';sa=pictures;album=' . $albumID, $context['start'], $context['album']['pictures_count'], $maxPictures, false);
	$context['current_page'] = $context['start'] / $maxPictures;
	
	// Show all albums.
	if ($context['start'] == 0) { // Child albums will be shown only on the first page.
		$request = db_query('SELECT ID_ALBUM, title, pictures
			FROM ' . $db_prefix . 'profile_albums
			WHERE ID_MEMBER = ' . $memID . ' 
				AND PARENT_ID = ' . $albumID, __FILE__, __LINE__);
		
		$context['albums'] = array();
		while ($row = mysql_fetch_assoc($request)) {
			$context['albums'][] = array(
				'id' => $row['ID_ALBUM'],
				'title' => $row['title'],
				'pictures_count' => $row['pictures'],
				'url' => $scripturl . '?action=profile;u=' . $memID . ';sa=pictures;album=' . $row['ID_ALBUM']
			);
		}
	}
	
	
	// Show all pictures.
	$request = db_query('SELECT ID_PICTURE, time, title, description, filename 
			FROM ' . $db_prefix . 'profile_pictures 
			WHERE ID_MEMBER = ' . $memID . ' 
				AND ID_ALBUM = ' . $albumID . '
			LIMIT ' . $context['start'] . ', ' . $maxPictures, __FILE__, __LINE__);
	while ($picture = mysql_fetch_assoc($request)) {
		$context['pictures'][] = array(
			'ID_PICTURE' => $picture['ID_PICTURE'],
			'title' => $picture['title'],
			'description' => $picture['description'],
			'url' => $scripturl . '?action=profile;u=' . $memID . ';sa=pictures;view=' . $picture['ID_PICTURE'],
			'thumb' => $modSettings['profile_pictures_url'] . '/' . $memID . '_' . $picture['time'] . '_thumb.' . get_extension($picture['filename']),
			'time' => timeformat($picture['time']),
		);
	}
	
	$context['sub_template'] = 'album_show';
}


function delete_picture ($picture_id)
{
	global $db_prefix, $modSettings, $context;
	
	$picture_id = (int)$picture_id;
		
	$request = db_query('SELECT ID_MEMBER, time, filename, ID_ALBUM 
		FROM ' . $db_prefix . 'profile_pictures 
		WHERE ID_PICTURE = "' . (int)$picture_id . '"', __FILE__, __LINE__);
	list($memID, $time, $filename, $album_id) = mysql_fetch_row($request);
	
	$normal_filename = $memID . '_' . $time . '.' . get_extension($filename);
	$thumb_filename = $memID . '_' . $time . '_thumb.' . get_extension($filename);
	
	db_query('DELETE FROM ' . $db_prefix . 'profile_pictures 
		WHERE ID_PICTURE = "' . $picture_id . '"', __FILE__, __LINE__);
	db_query('DELETE FROM ' . $db_prefix . 'picture_comments 
		WHERE COMMENT_PICTURE_ID = "' . $picture_id . '"', __FILE__, __LINE__);
	if ($album_id > 0)
		db_query('UPDATE ' . $db_prefix . 'profile_albums SET 
			pictures = pictures - 1 
			WHERE ID_ALBUM = ' . $album_id, __FILE__, __LINE__);
	
	@unlink($modSettings['profile_pictures_path'] . '/' . $normal_filename);
	@unlink($modSettings['profile_pictures_path'] . '/' . $thumb_filename);
	
	return $album_id;
}

function delete_album ($album_id)
{
	global $db_prefix;
	
	$album_id = (int)$album_id;
	
	$request = db_query('SELECT ID_ALBUM 
		FROM ' . $db_prefix . 'profile_albums 
		WHERE PARENT_ID = ' . $album_id, __FILE__, __LINE__);
	
	while ($album = mysql_fetch_assoc($request)) {
		$request2 = db_query('SELECT ID_PICTURE 
			FROM ' . $db_prefix . 'profile_pictures 
			WHERE ID_ALBUM = ' . $album['ID_ALBUM'], __FILE__, __LINE__);
		while ($picture = mysql_fetch_assoc($request2)) {
			delete_picture($picture['ID_PICTURE']);
		}
		db_query('DELETE FROM ' . $db_prefix . 'profile_albums 
			WHERE ID_ALBUM = ' . $album['ID_ALBUM'], __FILE__, __LINE__);
		
		delete_album($album['ID_ALBUM']);
	}
	
	$request = db_query('SELECT ID_PICTURE 
		FROM ' . $db_prefix . 'profile_pictures 
		WHERE ID_ALBUM = ' . $album_id, __FILE__, __LINE__);
	while ($picture = mysql_fetch_assoc($request)) {
		delete_picture($picture['ID_PICTURE']);
	}
	db_query('DELETE FROM ' . $db_prefix . 'profile_albums 
		WHERE ID_ALBUM = ' . $album_id, __FILE__, __LINE__);
}


function build_tree ($parent_album = '') {
	global $db_prefix, $context, $albums;
	
	// Load all the albums.
	$request = db_query ('SELECT ID_ALBUM, title, PARENT_ID 
		FROM ' . $db_prefix . 'profile_albums 
		WHERE ID_MEMBER = ' . $context['member']['id'], __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request)) {
		if ($parent_album !== $row['PARENT_ID'] && $parent_album !== $row['ID_ALBUM']) {
			$albums_temp[$row['PARENT_ID']][$row['ID_ALBUM']] = array(
				'id' => $row['ID_ALBUM'],
				'title' => $row['title'],
				'child_albums' => array()
			);
		}
	}
	
	$parents = @$albums_temp[0]; // Top-level albums
	$albums = array(); // Sorted list
	
	if (count($parents) > 0) {
		foreach ($parents as $key => $value) {
			$child_albums = isset($albums_temp[$key]) ? $albums_temp[$key] : array();
			
			if (count($child_albums) > 0) {
				foreach ($child_albums as $keySub => $valueSub) {
					if (array_key_exists($keySub, $albums_temp))
						$child_albums[$keySub]['child_albums'] = $albums_temp[$keySub];
				}
				$parents[$key]['child_albums'] = $child_albums;
			}
		}
		
		foreach ($parents as $key => $value) {
			$albums[] = array(
				'id' => $parents[$key]['id'],
				'title' => $parents[$key]['title'],
				'level' => 0
			);
			
			if (count($parents[$key]['child_albums']) > 0)
				children($parents[$key]['child_albums'], 1);
		}
	}
	
	return $albums;
}

function children ($children, $level) {
	global $albums;
	
	$level++;

	foreach ($children as $key => $value) {
		$albums[] = array (
			'id' => $children[$key]['id'],
			'title' => $children[$key]['title'],
			'level' => $level
		);
		
		if (count($children[$key]['child_albums']) > 0)
			children ($children[$key]['child_albums'], $level);
	}
}

?>