<?php
// Version: 0.8.5; ProfilePictures
// This file is a part of Ultimate Profile mod
// Author: Jovan Turanjanin

function template_pictures_edit()
{
	global $context, $scripturl, $settings, $txt;
	
	// The main containing header.
	echo '
		<form action="', $context['profile_action'] ,'" method="post" accept-charset="', $context['character_set'], '" name="picture" id="picture" enctype="multipart/form-data">
			<table border="0" width="85%" cellspacing="1" cellpadding="4" align="center" class="bordercolor">
				<tr class="titlebg">
					<td height="26">
						&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" align="top" />&nbsp;
						', $txt['profile_picture_caption'] ,'
					</td>
				</tr>
				<tr>
					<td class="windowbg2" style="padding-bottom: 2ex;">
						<table border="0" width="100%" cellpadding="5" cellspacing="0">
							<tr>
								<td width="30%" valign="top">
									<b>', $txt['profile_picture_title'] ,'</b>
								</td>
								<td>
									<input type="text" name="title" value="', @$context['picture_title'] ,'" /><br />';
	echo '						</td>
							</tr>';
	
	echo '
							<tr>
								<td width="30%" valign="top">
									<b>', $txt['profile_picture_description'] ,':</b>
								</td>
								<td>
									<textarea class="editor" name="description" rows="8" cols="65">', @$context['picture_description'] ,'</textarea><br />	
								</td>
							</tr>';
	echo '						
							<tr>
								<td width="30%" valign="top">
									<b>', $txt['profile_album_parent'] ,'</b>
								</td>
								<td>
								<select name="album_id" id="album_id">
										<option value="0">' . $txt['profile_album_basic'] . '</option>';
								foreach ($context['album_tree'] as $album)
								{	
										echo '
										<option value="', $album['id'] ,'"', (@$context['album_parent'] == $album['id']) ? ' selected="selected"' : '', '> ' . str_repeat('=', $album['level']) . '=> ' . $album['title'] . '</option>';
								}
								echo '
									</select>
								</td>
							</tr>';
	
	if ($context['picture_upload'])
		echo '
							<tr>
								<td>
									<b>', $txt['profile_picture_path'] ,':</b>
								</td>
								<td>
									<input type="file" name="picture" />
								</td>
							</tr>';
							
	echo '
							<tr>
								<td align="right" colspan="2">
									<input type="submit" value="', $txt[10], '" />
									<input type="hidden" name="sc" value="', $context['session_id'], '" />
								</td>
							</tr>	
						</table>
					</td>
				</tr>
			</table>
		</form>';
}


function template_album_show()
{
	global $context, $settings, $txt, $scripturl, $sc;
	
	echo '
	<table border="0" width="85%" cellspacing="1" cellpadding="4" align="center" class="bordercolor">
		<tr class="titlebg">
			<td height="26">
				&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" align="top" />&nbsp;
				<a href="', $scripturl ,'?action=profile;u=', $context['member']['id'] ,'">', $context['member']['name'] ,'</a> - <a href="', $scripturl ,'?action=profile;u=', $context['member']['id'] ,';sa=pictures">', $txt['profile_picture_caption'] , '</a> ' , 
				(isset($context['album']['title'])) ? ' - ' . $context['album']['title']
				: '', '
			</td>
		</tr>';
	
	if (!empty($context['albums'])) {
	
		echo '
		<tr>
			<td class="windowbg" style="padding-bottom: 2ex;">
				<table border="0" cellpadding="4" cellspacing="1" width="100%" id="albums">';
		foreach ($context['albums'] as $album) {
			echo '
				<tr>
					<td width="5%"><img src="', $settings['images_url'] ,'/board.gif" alt="" /></td>
					<td><a href="', $album['url'] ,'">', $album['title'] ,'</a><br /><div class="smalltext">', $txt['profile_albums_pic_count'] ,': ', $album['pictures_count'] ,'</div></td>
				</tr>';
		}
		
		echo '	</table>
			</td>
		</tr>';		
	}
	
	if (!empty($context['pictures'])) {
		echo '
		<tr>
			<td class="windowbg2" style="padding-bottom: 2ex;">
				<table border="0" cellpadding="4" cellspacing="1" width="100%" id="pictures">';
							
			
				$i = 1;
				foreach ($context['pictures'] as $picture) {
					if ($i == 1)
						echo '
						<tr>';
						
						echo '
							<td align="center" valign="top" class="windowbg2" style="clear: both;">
								<a href="', $picture['url'] ,'"><img src="', $picture['thumb'] ,'" alt="" title="', $picture['description'], '" border="0" /></a>
								<br />
								<b>', $picture['title'], '</b>
							</td>';
					
					if ($i == 3)
						echo '
						</tr>';
					
					$i++;
					if ($i == 4) $i = 1;
				}				
			echo '
				</table>
			</td>
		</tr>';
	} else 
		if (empty($context['albums']))
			echo '
			<tr>
				<td class="windowbg2" style="padding-bottom: 2ex;">', $txt['profile_pictures_no'] ,'</td>
			</tr>';
	
	echo '
	</table>';
	
	// Show more page numbers.
	echo '
	<table border="0" width="85%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
		<tr>
			<td colspan="3" class="catbg3">
				', $txt[139], ': ', $context['page_index'], '
			</td>
		</tr>
	</table>';
	
	if ($context['can_add'])
		echo '<br />
		<table border="0" width="85%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
		<tr class="titlebg">
			<td height="26">
				<div style="float: left;">
					<a href="', $scripturl ,'?action=profile;u=', $context['member']['id'] , ';sa=pictures;add=' . $context['album']['id'] . '">', $txt['profile_picture_add'] ,'</a>
				</div>
				<div style="float: right;">
					', (isset($context['can_add'])) ? 
						' <a href="' . $scripturl . '?action=profile;u=' . $context['member']['id'] . ';sa=pictures;addalb=' . $context['album']['id'] . '"><img src="' . $settings['images_url'] . '/buttons/im_reply.gif" alt="' . $txt['profile_album_add'] . '" title="' . $txt['profile_album_add'] . '" /></a> '
					: '', 
					(isset($context['can_edit'])) ? 
						  '<a href="' . $scripturl . '?action=profile;u=' . $context['member']['id'] . ';sa=pictures;editalb=' . $context['album']['id'] . '"><img src="' . $settings['images_url'] . '/buttons/modify.gif" alt="' . $txt['profile_album_edit'] . '" title="' . $txt['profile_album_edit'] . '" /></a>  
						  <a onclick="javascript:return confirm(\'' . $txt['profile_album_delete_confirm'] . '\')" href="' . $scripturl . '?action=profile;u=' . $context['member']['id'] . ';sa=pictures;deletealb=' . $context['album']['id'] . ';sesc=' . $sc . '"><img src="' . $settings['images_url'] . '/buttons/delete.gif" alt="' . $txt['profile_album_delete'] . '" title="' . $txt['profile_album_delete'] . '" /></a>'  
					: '', '
				</div>
			</td>
		</tr>
		</table>';
}

function template_pictures_view()
{
	global $context, $settings, $txt, $scripturl;
	
	echo '
	<table border="0" width="85%" cellspacing="1" cellpadding="4" align="center" class="bordercolor">
		<tr class="titlebg">
			<td height="26">
				&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" align="top" />&nbsp;
				<a href="', $scripturl , '?action=profile;u=', $context['member']['id'], ';sa=pictures">', sprintf ($txt['profile_picture_members'], $context['member']['name']) ,'</a> - ', 
				(isset($context['album']['title'])) ? '<a href="' . $scripturl . '?action=profile;u=' . $context['member']['id'] . ';sa=pictures;album=' . $context['picture']['ID_ALBUM'] . '">' . $context['album']['title'] . '</a> - ' : '',
				$context['picture']['title'] ,'
			</td>
		</tr>
		<tr class="windowbg">
			<td class="smalltext" height="25" style="padding: 2ex;">
				', $context['picture']['description'] ,'
			</td>
		</tr>
		<tr>
			<td class="windowbg2" align="center" style="padding-bottom: 2ex;">
				<img src="', $context['picture']['image'] ,'" alt="" />
				
				<br /><br />';
		if (isset($context['picture']['edit'])) {
			echo '
				<div align="right" class="smalltext">
					<a href="', $context['picture']['edit'] ,'">', $txt['profile_picture_edit'] ,'</a> &nbsp;
					<a href="', $context['picture']['delete'] ,'">', $txt['profile_picture_delete'] ,'</a>
				</div>';
		}
		echo '
				<div style="float: left;" class="smalltext">';
		if ($context['picture']['previous_id'])
			echo '
					&nbsp;<a href="', $scripturl ,'?action=profile;u=', $context['member']['id'] ,';sa=pictures;view=', $context['picture']['previous_id'],'">', $txt['profile_picture_previous'] ,'</a>&nbsp;';
		if ($context['picture']['next_id'])
			echo '
					&nbsp;<a href="', $scripturl ,'?action=profile;u=', $context['member']['id'] ,';sa=pictures;view=', $context['picture']['next_id'],'">', $txt['profile_picture_next'] ,'</a>&nbsp;';
	
	echo '		</div>
			</td>
		</tr>
	</table>
	<br />';
	
	if (@$context['member']['options']['comments_disable'] != 1) {
		echo '
	
	<script type="text/javascript">
	function comment() {
		document.getElementById("comment").style.display = "block";
	}
	</script>
	
	<table border="0" cellpadding="4" cellspacing="1" align="center" class="bordercolor" width="65%" id="post_comments">
		<tr>
			<td class="titlebg"><a href="javascript:void(0);" onclick="comment()">', $txt['profile_comment_add'] ,'</a></td>
		</tr>
		<tr id="comment" class="windowbg" style="display: none;">
			<td>
				<form action="', $scripturl ,'?action=profile;u=', $context['member']['id'] ,';sa=pictures;comment=', (int)$_GET['view'] ,'" method="post">
					', $txt['profile_comment'] ,'<br />
					<textarea  cols="50" rows="4" name="comment"></textarea><br />
					<br />
					<input type="submit" value="', $txt[10] ,'" />
					<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>
	
	<br />
	
	<table border="0" cellpadding="4" cellspacing="1" align="center" class="bordercolor" width="100%" id="comments">
		<tr>
			<td class="titlebg" colspan="2" align="center">', $txt['profile_comments'] ,'</td>
		</tr>';
		
		// Only show comments if they have made some!
		if (!empty($context['comments'])) {
			foreach ($context['comments'] as $comment) {
				echo '
			
		<tr>
			<td class="windowbg" align="center" valign="top">
				<b><a href="', $scripturl ,'?action=profile;u=', $comment['author']['ID_MEMBER'] ,'">', $comment['author']['realName'] ,'</a></b>
				<div class="smalltext">
					', $comment['author']['avatar'] ,'<br /><br />
					<i>', $settings['use_image_buttons'] ? '<img src="' . $comment['author']['online']['image_href'] . '" alt="' . $comment['author']['online']['text'] . '" align="middle" />' : $comment['author']['online']['text'], $settings['use_image_buttons'] ? '<span class="smalltext"> ' . $comment['author']['online']['text'] . '</span>' : '', '</i>
				</div>
			</td>
			<td class="windowbg2" valign="top">
				<table width="100%">
					<tr>
						<td><span class="smalltext">', $comment['time'] ,'</span><hr /></td>
					</tr>
					<tr>
						<td>', $comment['body'] ,'</td>
					</tr>';
				if ($context['can_delete'])
					echo '
					<tr>
						<td align="right" valign="bottom" class="smalltext">
							<a href="', $comment['delete'], '">', $txt['profile_comment_delete'] ,'</a>
						</td>
					</tr>';
					
					echo '
				</table>
			</td>
		</tr>';
			
			}
	
		}
		else
			echo '
		<tr class="windowbg2">
			<td colspan="2">', $txt['profile_comment_no'] ,'</td>
		</tr>';
	
	echo '
	</table>';
	
	// Show more page numbers.
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
		<tr>
			<td colspan="3" class="catbg3">
				', $txt[139], ': ', $context['page_index'], '
			</td>
		</tr>
	</table>';
	}
}

function template_albums_edit()
{
	global $context, $scripturl, $settings, $txt;
	
	// The main containing header.
	echo '
		<form action="', $context['profile_action'] ,'" method="post" accept-charset="', $context['character_set'], '" name="album" id="album">
			<table border="0" width="85%" cellspacing="1" cellpadding="4" align="center" class="bordercolor">
				<tr class="titlebg">
					<td height="26">
						&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" align="top" />&nbsp;
						', $txt['profile_picture_caption'] ,'
					</td>
				</tr>
				<tr>
					<td class="windowbg2" style="padding-bottom: 2ex;">
						<table border="0" width="100%" cellpadding="5" cellspacing="0">
							<tr>
								<td width="30%" valign="top">
									<b>', $txt['profile_album_title'] ,'</b>
								</td>
								<td>
									<input type="text" name="title" value="', @$context['album_title'] ,'" /><br />
								</td>
							</tr>
							<tr>
								<td width="30%" valign="top">
									<b>', $txt['profile_album_parent'] ,'</b>
								</td>
								<td>
								<select name="parent_id" id="parent_id">
										<option value="0">' . $txt['profile_album_basic'] . '</option>';
								foreach ($context['album_tree'] as $album)
								{	
										echo '
										<option value="', $album['id'] ,'"', ($context['album_parent'] == $album['id']) ? ' selected="selected"' : '', '> ' . str_repeat('=', $album['level']) . '=> ' . $album['title'] . '</option>';
								}
								echo '
									</select>
								</td>
							</tr>
							<tr>
								<td align="right" colspan="2">
									<input type="submit" value="', $txt[10], '" />
									<input type="hidden" name="sc" value="', $context['session_id'], '" />
								</td>
							</tr>	
						</table>
					</td>
				</tr>
			</table>
		</form>';
}

?>